unit uFabricaPrazos;

interface

uses
  uInterfaces;

type
  TFabricaPrazos = class(TInterfacedObject, IFactoryMethod)
    function ConsultarPrazo(const Prazo: string): ITipoPrazo;
  end;

implementation

uses
  uTipoPrazos;

{ TFabricaPrazos }

function TFabricaPrazos.ConsultarPrazo(const Prazo: string): ITipoPrazo;
begin
  // Factory Method
  // A deciso de qual mtodo criar fica a critrio deste mtodo

  if Prazo = 'Mensal' then
    result := TPrazoMensal.Create
  else if Prazo = 'Semestral' then
    result := TPrazoSemestral.Create
  else if Prazo = 'Anual' then
    result := TPrazoAnual.Create;
end;

end.
